// Filter fr Dateisuche mit Wildcards

import java.io.*;

class WildcardFilter implements java.io.FilenameFilter {
  String wildcard;
  WildcardFilter(String w) { wildcard=w; }
  public boolean accept(File dir, String name) {
    return match(name, 0, 0);
  }
  // Name ab nn mit Wildcard ab nw vergleichen
  boolean match(String name, int nn, int nw) {
    while(nn<name.length() && nw<wildcard.length()) {
      if(wildcard.charAt(nw)=='?') {
        if(name.charAt(nn++)=='.') return false;   // ?: Zeichen mu kommen
        ++nw;
      }
      else if(wildcard.charAt(nw)=='*') {          // *: Beliebig viele Zeichen
        while(nn<=name.length()) {
          if(match(name, nn++, nw+1)) return true;
        }
        return false;
      }
      else
        if(name.charAt(nn++)!=wildcard.charAt(nw++))
          return false;
    }
    while(nw<wildcard.length() && wildcard.charAt(nw)=='*')
      ++nw;
    return nn==name.length() && nw==wildcard.length();
  }
}
