// APPLET:   SysPropApplet.java
// FUNKTION: Zeigt verschiedene System-Eigenschaften
//           in einem Textfeld an
// AUTOR:    Gerhard Schild

import java.applet.*;
import java.io.*;
import java.awt.*;

public class SysPropApplet extends Applet {
  TextArea a;
  // System-Eigenschaft an das Textfeld anhngen
  void addProp(String prefix, String name) {
    a.appendText(prefix);
    // Der Zugriff ist nicht immer mglich!
    try {
      String val=System.getProperty(name);
      a.appendText(val);
    } catch(Exception e) {
      a.appendText(" <Zugriff verweigert>");
    } finally {
      a.appendText(" ["+name+"]\n");
    }
  }
  // Applet initialisieren
  public void init() {
    setLayout(new BorderLayout());
    // Textfeld erzeugen
    add("Center", a=new TextArea());
    // Verschiedene Eigenschaften anhngen
    addProp("Ihr Browser untersttzt Java Version ", "java.version");
    addProp("Ihre Java Virtual Machine stammt von ", "java.vendor");
    addProp("Kontaktadresse: ", "java.vendor.url");
    addProp("Ihr Browser luft unter ", "os.name");
    addProp("Ihre Rechnerarchitektur ist ", "os.arch");
    addProp("Ihr Java-System ist installiert in ", "java.home");
    addProp("Ihr Benutzername ist ", "user.name");
    addProp("Ihr Benutzerverzeichnis ist ", "user.home");
  }
}

